﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using System.Diagnostics;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
	{
		
        this.WebHierarchicalDataGrid1.DataSource = this.GetDs();
        this.WebHierarchicalDataGrid1.DataBind();

        DropDownProvider dpFN = (DropDownProvider)this.WebHierarchicalDataGrid1.EditorProviders["ddp_fName"];

        dpFN.EditorControl.DataSource = GetDs().Tables[1];
        
        dpFN.EditorControl.Width = Unit.Pixel(200);

        dpFN.EditorControl.TextField="FirstName";

        dpFN.EditorControl.ValueField = "EmployeeID";


        DropDownProvider dpLN = (DropDownProvider)this.WebHierarchicalDataGrid1.EditorProviders["ddp_lName"];

        dpLN.EditorControl.DataSource = GetDs().Tables[1];

        dpLN.EditorControl.Width = Unit.Pixel(200);

        dpLN.EditorControl.TextField = "LastName";

        dpLN.EditorControl.ValueField = "EmployeeID";

    }



    #region SampleData

    private DataSet GetDs()
    {
        DataTable tblEmp = this.GetEmployees(10);
        DataTable tblEmpDetails = this.GetEmployeeDetails(10);

        DataSet dsEmp = new DataSet();
        dsEmp.Tables.Add(tblEmp);
        dsEmp.Tables.Add(tblEmpDetails);

        DataRelation rel = new DataRelation("empRelation", dsEmp.Tables["Employees"].Columns["EmployeeID"], dsEmp.Tables["EmployeeDetails"].Columns["EmployeeID"]);
        dsEmp.Relations.Add(rel);

        return dsEmp;
    }

    private DataTable GetEmployees(int count)
    {
        DataTable dtData = new DataTable("Employees");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("Name", typeof(string));
        dtData.Columns.Add("OnSite", typeof(bool));
        dtData.Columns.Add("DateOfHire", typeof(DateTime));
        dtData.Columns.Add("Department", typeof(int));
        dtData.Columns.Add("Site", typeof(string));

        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), (i % 2 == 0), DateTime.Today.Date.AddDays(-1 * i), i % 8, "http://www.google.com" });
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }

    private DataTable GetEmployeeDetails(int count)
    {
        DataTable dtData = new DataTable("EmployeeDetails");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("FirstName", typeof(string));
        dtData.Columns.Add("LastName", typeof(string));
        dtData.Columns.Add("Address", typeof(string));

        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("First Name {0}", i), string.Format("Last Name {0}", i), string.Format("Address {0}", i) });
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }

    #endregion SampleData


	protected void WebHierarchicalDataGrid1_Init(object sender, EventArgs e)
	{
		WebHierarchicalDataGrid1.DataMember = "Employees";
		WebHierarchicalDataGrid1.DataKeyFields = "EmployeeID";

		AddBandColumn(WebHierarchicalDataGrid1, "EmployeeID", "", true);
		AddBandColumn(WebHierarchicalDataGrid1, "Name", "", false);
		AddBandColumn(WebHierarchicalDataGrid1, "OnSite", "", false);
		AddBandColumn(WebHierarchicalDataGrid1, "DateOfHire", "", false);

		FormatBandColumn(WebHierarchicalDataGrid1, "EmployeeID", "EmployeeID", true);
		FormatBandColumn(WebHierarchicalDataGrid1, "Name", "Name", false);
		FormatBandColumn(WebHierarchicalDataGrid1, "OnSite", "OnSite", false);
		FormatBandColumn(WebHierarchicalDataGrid1, "DateOfHire", "DateOfHire", false);

		Band childBand = new Band();
		WebHierarchicalDataGrid1.Bands.Add(childBand);
		childBand.DataMember = "EmployeeDetails";
		childBand.DataKeyFields = "EmployeeID";

		AddBandColumn(childBand, "EmployeeID", "", true);
		AddBandColumn(childBand, "FirstName", "", false);
		AddBandColumn(childBand, "LastName", "", false);
		AddBandColumn(childBand, "Address", "", false);

		FormatBandColumn(childBand, "EmployeeID", "EmployeeID", true);
		FormatBandColumn(childBand, "FirstName", "FirstName", false);
		FormatBandColumn(childBand, "LastName", "LastName", false);
		FormatBandColumn(childBand, "Address", "Address", false);

		
	}

    public void AddBandColumn(IBand band, string dataFiled, string Caption, bool hidden) //, AllowUpdate updatable)
    {
        BoundDataField column = new BoundDataField();
        column.DataFieldName = dataFiled + "".ToString();
        column.Key = dataFiled;
        column.Hidden = hidden;
        column.Header.Text = Caption;
        band.Columns.Add(column);
    }

    public void FormatBandColumn(IBand band, string key, string Caption, bool hidden)
    {
        band.Columns[key].Hidden = hidden;
        band.Columns[key].Header.Text = Caption;

    }

    

    protected void WebHierarchicalDataGrid1_RowAdding(object sender, RowAddingEventArgs e)
    {
        ContainerGrid containerGrid = (ContainerGrid)sender;

        System.Diagnostics.Debug.WriteLine("RowAdding fired for level: " + containerGrid.Key);
    }


    protected void WebHierarchicalDataGrid1_RowsDeleting(object sender, RowDeletingEventArgs e)
    {

        ContainerGrid containerGrid = (ContainerGrid)sender;

        System.Diagnostics.Debug.WriteLine("RowDeleting fired for level: " + containerGrid.Key);
    }


    protected void WebHierarchicalDataGrid1_RowUpdating(object sender, RowUpdatingEventArgs e)
    {
        ContainerGrid containerGrid = (ContainerGrid)sender;

        System.Diagnostics.Debug.WriteLine("RowUpdating fired for level: " + containerGrid.Key);
    }


	protected void WebHierarchicalDataGrid1_Init1(object sender, EventArgs e)
	{
		this.WebHierarchicalDataGrid1.Bands[0].RowAdding += new RowAddingHandler(WebHierarchicalDataGrid1_RowAdding);
		this.WebHierarchicalDataGrid1.Bands[0].RowUpdating += new RowUpdatingHandler(WebHierarchicalDataGrid1_RowUpdating);
		this.WebHierarchicalDataGrid1.Bands[0].RowsDeleting += new RowDeletingHandler(WebHierarchicalDataGrid1_RowsDeleting);
	}
}